#include <hdf5.h>
main() {
char H5FILE_NAME[128];
hid_t file_id;              /* file identifier */
hid_t group1_id, group2_id, group3_id, groupP_id;  /* group identifier */
hid_t group1P_id, group1V_id; /* sub-group idientifier */
hid_t group2P_id, group2V_id; /* sub-group idientifier */
hid_t group3P_id, group3V_id; /* sub-group idientifier */
hid_t groupPS_id, groupPV_id; /* sub-group idientifier */
herr_t status;

/* filename */
sprintf(H5FILE_NAME,"RUN/%s.h5","my_file");
printf("creating h5 file: %s with group...",H5FILE_NAME);

/* Create a new file using default properties. */
file_id = H5Fcreate (H5FILE_NAME,H5F_ACC_TRUNC,H5P_DEFAULT,H5P_DEFAULT);

/* Create a group  */
group1_id = H5Gcreate(file_id, "/100",H5P_DEFAULT,H5P_DEFAULT,H5P_DEFAULT);
group2_id = H5Gcreate(file_id, "/200",H5P_DEFAULT,H5P_DEFAULT,H5P_DEFAULT);
group3_id = H5Gcreate(file_id, "/300",H5P_DEFAULT,H5P_DEFAULT,H5P_DEFAULT);
groupP_id = H5Gcreate(file_id, "/PARAMETERS",H5P_DEFAULT,H5P_DEFAULT,H5P_DEFAULT);

/* Create sub-group */
group1P_id = H5Gcreate(file_id, "/100/PRESSURE", H5P_DEFAULT, H5P_DEFAULT, H5P_DEFAULT); 
group2P_id = H5Gcreate(file_id, "/200/PRESSURE", H5P_DEFAULT, H5P_DEFAULT, H5P_DEFAULT); 
group3P_id = H5Gcreate(file_id, "/300/PRESSURE", H5P_DEFAULT, H5P_DEFAULT, H5P_DEFAULT); 
groupPS_id = H5Gcreate(file_id, "/PARAMETERS/SIZE", H5P_DEFAULT, H5P_DEFAULT, H5P_DEFAULT); 

group1V_id = H5Gcreate(group1_id, "VELOCITY", H5P_DEFAULT, H5P_DEFAULT, H5P_DEFAULT); 
group2V_id = H5Gcreate(group2_id, "VELOCITY", H5P_DEFAULT, H5P_DEFAULT, H5P_DEFAULT); 
group3V_id = H5Gcreate(group3_id, "VELOCITY", H5P_DEFAULT, H5P_DEFAULT, H5P_DEFAULT); 
groupPV_id = H5Gcreate(groupP_id, "VISCOSITY", H5P_DEFAULT, H5P_DEFAULT, H5P_DEFAULT); 

/* Close all the groups. */
status = H5Gclose(group1_id);
status = H5Gclose(group1V_id);
status = H5Gclose(group1P_id);

status = H5Gclose(group2_id); 
status = H5Gclose(group2V_id);
status = H5Gclose(group2P_id);

status = H5Gclose(group3_id); 
status = H5Gclose(group3V_id);
status = H5Gclose(group3P_id);

status = H5Gclose(groupP_id); 
status = H5Gclose(groupPV_id);
status = H5Gclose(groupPS_id);

/* Terminate access to the file. */
status = H5Fclose (file_id);
printf("...done\n");
}

