!
      program ex5
!
      use HDF5
      implicit none
!
      character(len=20), parameter :: file_name="RUN/my_4th_file.h5"
      integer(hid_t) :: file_id       !! file identifier
      integer(hid_t) :: group_id      !! group identifier
      integer(hid_t) :: groupA_id     !! sub-group identifier
      integer(hid_t) :: groupB_id     !! sub-group identifier
      integer(hid_t) :: dataset_id    !! dasaset identifier
      integer(hid_t) :: dataspace_id  !! dataspace identifier
      integer(hid_t) :: dc_pl         !! property list
      integer(hsize_t) :: dims(2)
      integer        :: hdferr
      integer        :: i,j 
      integer        :: dset_data(4,6)
!
! set size...
      dims(1) = 4
      dims(2) = 6
!
! set dset_data
      do j = 1, dims(2)
         do i = 1, dims(1)
            dset_data(i,j) = (j-1)*dims(1) + i 
         enddo
      enddo
!
      write(6,*) "opening ", file_name, " and fill the dataset"
!
! open the fortran interface for hdf5   
      call h5open_f(hdferr);

! opening an exisiting file...
      call h5fopen_f(file_name, H5F_ACC_RDWR_F, file_id, hdferr, &
                     H5P_DEFAULT_F)

! open an existing dataset 
      call h5dopen_f(file_id, "my_dset", dataset_id, &
                     hdferr, H5P_DEFAULT_F)

      call h5dwrite_f(dataset_id, H5T_NATIVE_INTEGER, dset_data, dims, &
                    hdferr, H5S_ALL_F, H5S_ALL_F, H5P_DEFAULT_F)


! close dataspace & dataset
      call h5dclose_f(dataset_id, hdferr)

! close the file 
      call h5fclose_f(file_id, hdferr)

! close the interface
      call h5close_f(hdferr);

      write(6,*) ".... done"

      end program ex5

